<?php

namespace ACL\Repositories;

use ACL\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class Perfacessparc extends RepositoryBase {

    Use TQuery;

    protected $table = 'PERFACCESSPARC';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    /**
     * @param array $perfacessparc
     * @param $organizationId
     * @throws \Doctrine\DBAL\Driver\Exception
     * @throws \Doctrine\DBAL\Exception
     */
    public function savePerfaccessparc(array $perfacessparc, $organizationId)
    {
        $query = "INSERT INTO PERFACESSPARC
                              (NRPERFACESSPARC, NRORG, NRPARCNEGOCIO, NRPERFILACESSO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, DTVALIDADE)
                       VALUES (:NRPERFACESSPARC, :NRORG, :NRPARCNEGOCIO, :NRPERFILACESSO, SYSDATE, :NRORG, :CDOPERINCLUSAO, :DTVALIDADE)";

        $params = array(
            "NRPERFACESSPARC"   => $perfacessparc['NRPERFACESSPARC'],
            "NRORG"             => $perfacessparc['NRORG'],
            "NRPARCNEGOCIO"     => $perfacessparc['NRPARCNEGOCIO'],
            "NRPERFILACESSO"    => $perfacessparc['NRPERFILACESSO'],
            "CDOPERINCLUSAO"    => $perfacessparc['CDOPERINCLUSAO'],
            "DTVALIDADE"        => $perfacessparc['DTVALIDADE'],
        );

        try {
            $std = $this->entityManager->getConnection()->prepare($query);
            $std->executeQuery($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deletePerfaccessparc($nrperfacessparc, $organizationId)
    {
        $query = "DELETE
                    FROM PERFACESSPARC
                   WHERE NRPERFACESSPARC = :NRPERFACESSPARC
                     AND NRORG           = :NRORG";

        $params = array(
            'NRPERFACESSPARC'   => $nrperfacessparc,
            'NRORG'             => $organizationId
        );

        try {
            $std = $this->entityManager->getConnection()->prepare($query);
            $std->executeQuery($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
}
