<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Operador as OperadorRepository;
use Zeedhi\Framework\Remote\FileUploader\Server;

class Operador {

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var OperadorRepository
     */
    private $operadorRepository;

    /**
     * @var // FileServerFilesUrl
     */
    private $fileServerFilesUrl;
    /**
     * @var Server
     */
    private $zhFileUploader;

    public function __construct($fileServerFilesUrl, Server $zhFileUploader,OperadorRepository $operadorRepository)
    {
        $this->fileServerFilesUrl = $fileServerFilesUrl;
        $this->zhFileUploader = $zhFileUploader;
        $this->operadorRepository = $operadorRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    public function findOperadoresByPerfilAcesso($nrperfilacesso)
    {
        $organizationId = InstanceProvider::getLibEnvironment()->getCurrentOrganizationId();
        return $this->operadorRepository->findOperadoresByPerfilAcesso($nrperfilacesso, $organizationId);
    }

    public function findOperadoresForAddPerfilAcesso($nrperfilacesso)
    {
        $organizationId = InstanceProvider::getLibEnvironment()->getCurrentOrganizationId();
        return $this->operadorRepository->findOperadoresForAddPerfilAcesso($nrperfilacesso, $organizationId);
    }
}
