<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Perfacessparc as PerfacessparcRepository;

class Perfacessparc {

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var PerfacessparcRepository
     */
    private $perfacessparcRepository;

    public function __construct(PerfacessparcRepository $perfacessparcRepository)
    {
        $this->perfacessparcRepository = $perfacessparcRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    public function savePerfaccessparc($rows)
    {
        $organizationId = $this->libEnvironment->getCurrentOrganizationId();

        foreach ($rows as $perfacessparc) {
            $this->setParcnegocio($perfacessparc);

            $perfacessparc['NRPERFACESSPARC'] = InstanceProvider::getNewCode()->getCodeByTableName('PERFACESSPARC', $organizationId);
            $perfacessparc = $this->perfacessparcRepository->auditValuesFieldArrayMerge($perfacessparc,
                                                                        $this->perfacessparcRepository->getAuditFieldValuesDefaultInsert());
            $this->perfacessparcRepository->savePerfaccessparc($perfacessparc, $organizationId);
        }
        return [];
    }

    public function deletePerfaccessparc($rows)
    {
        $organizationId = $this->libEnvironment->getCurrentOrganizationId();
        foreach ($rows as $row) {
            $this->perfacessparcRepository->deletePerfaccessparc($row['NRPERFACESSPARC'], $organizationId);
        }
    }

    private function setParcnegocio(&$perfacessparc)
    {
        $parcnegocioService = InstanceProvider::getService()->getParcnegocio();
        $cdtipoinscricao = 'LIVRE';
        $nrinscricaoparc = null;

        if (!$perfacessparc['NRPARCNEGOCIO']) {
            $data = $parcnegocioService->setParcnegocio($perfacessparc['NMOPERADOR'], $nrinscricaoparc,
                $cdtipoinscricao, $perfacessparc['CDOPERADOR']);
            $perfacessparc['NRPARCNEGOCIO'] = $data['NRPARCNEGOCIO'];
        }
    }
}
