import { AlertService } from '@zeedhi/common';
import Messages from '@/services/Messages';
import { Utilities } from '@/services/Utilities';

export class AclAlertService extends AlertService {
	public static showSuccess(msg: string) {
		this.show({
			name: Utilities.getNameDynamic('success_alert'),
            color: 'success',
            text: msg,
            timeout: 3000,
            showDismiss: true,
            top: true,
            right: true,
		});
	}

    public static defaultDeleteSuccessAlert() {
		this.show({
			name: 'success_delete_alert',
            color: 'success',
            text: Messages.SUCCESS_DELETE_DEAFULT,
            timeout: 3000,
            showDismiss: true,
            top: true,
            right: true,
		});
	}

    public static customErrorAlert(text: string) {
        AlertService.show({
            name: 'custom_error_alert',
            text,
            color: 'error',
            timeout: 3000,
            showDismiss: true,
            top: true,
            right: true,
        });
    }
}
